VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsVxmDriverVb6"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'*** Use loadlibrary and getprocaddress to see if the driver functions exist
Private Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32.dll" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32.dll" (ByVal hLibModule As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes As Long)

'*** VXM Driver Functions (use ONLY in VB6)
Private Declare Function ShowTerminal Lib "VxmDriver.dll" Alias "ShowTerminalSimple" (ByVal ParentHwnd As Long) As Long
Private Declare Function HideTerminal Lib "VxmDriver.dll" Alias "HideTerminalSimple" () As Long
Private Declare Function OpenPort Lib "VxmDriver.dll" (ByVal ComPortNumber As Long, ByVal ComPortBaudRate As Long) As Long
Private Declare Function IsPortOpen Lib "VxmDriver.dll" () As Long
Private Declare Function ClosePort Lib "VxmDriver.dll" () As Long                    'Close serial port
Private Declare Function DriverSendToPort Lib "VxmDriver.dll" (ByVal CommandOut As String) As Long                           'Send Command
Private Declare Function ReadFromPort Lib "VxmDriver.dll" () As String                       'Get reply from device
Private Declare Function CountCharsAtPort Lib "VxmDriver.dll" () As Long                          'Count Number of Chars at port
Private Declare Function SearchForChars Lib "VxmDriver.dll" (ByVal CharsToFind As String) As Long
Private Declare Function ClearPort Lib "VxmDriver.dll" () As Long                    'Clear buffer
Private Declare Function RemoveFromPort Lib "VxmDriver.dll" (ByVal StringToRemove As String) As Long                         'Clear buffer chars
Private Declare Function GetMotorPosition Lib "VxmDriver.dll" (ByVal MotorNumber As Long) As String
Private Declare Function WaitForChar Lib "VxmDriver.dll" (ByVal CharToWaitFor As String, Optional ByVal TimeOutTime As Long) As Long
Private Declare Function WaitForCharWithMotorPosition Lib "VxmDriver.dll" (ByVal CharToWaitFor As String, ByVal MotorNumber As Long, Optional ByVal ReportToWindowHwnd As Long, Optional ByVal TimeOutTime As Long) As Long
Private Declare Sub ResetDriverFunctions Lib "VxmDriver.dll" ()

'*** Handle for Driver Functions
Private hLib As Long                        'Driver
Private hShowTerminal As Long               'ShowTerminal
Private hHideTerminal As Long               'HideTerminal
Private hPortOpen As Long                   'Port Open
Private hPortClose As Long                  'Port Close
Private hIsPortOpen As Long                 'Is Port Open
Private hSendToPort As Long                 'Send to Port
Private hReadFromPort As Long               'Read from Port
Private hCountChars As Long                 'Count Chars at Port
Private hSearchForChars As Long             'Search for Chars
Private hClearPort As Long                  'Clear Port
Private hRemoveFromPort As Long             'Remove Chars from Port
Private hGetMotorPosition As Long           'Get Motor Position
Private hWaitForChar As Long                'Wait for Char
Private hWaitForCharMotorPosition As Long   'Wait for Char and Get Motor Position while waiting
Private hResetDriverFunctions As Long       'Reset Driver Functions for recovery


'*** Subroutine to initialize parameters before running driver
Private Sub Class_Initialize()
End Sub

'*** Subroutine to clean up parameters after done with driver
Private Sub Class_Terminate()
    ClosePort
    HideTerminal
    FreeLibrary hLib
End Sub

Public Function LoadDriver(ByVal PathToDll As String) As Long
    hLib = LoadLibrary(PathToDll)                        'Driver
    Select Case hLib
        Case 0
        Case Else
            hShowTerminal = GetProcAddress(hLib, "ShowTerminalSimple")                  'ShowTerminal
            hHideTerminal = GetProcAddress(hLib, "HideTerminalSimple")                  'HideTerminal
            hPortOpen = GetProcAddress(hLib, "OpenPort")                                'Port Open
            hPortClose = GetProcAddress(hLib, "ClosePort")                              'Port Close
            hIsPortOpen = GetProcAddress(hLib, "IsPortOpen")                            'Is Port Open
            hSendToPort = GetProcAddress(hLib, "DriverSendToPort")                      'Send to Port
            hReadFromPort = GetProcAddress(hLib, "ReadFromPort")                        'Read from Port
            hCountChars = GetProcAddress(hLib, "CountCharsAtPort")                      'Count Chars at Port
            hSearchForChars = GetProcAddress(hLib, "SearchForChars")                    'Search for Chars
            hClearPort = GetProcAddress(hLib, "ClearPort")                              'Clear Port
            hRemoveFromPort = GetProcAddress(hLib, "RemoveFromPort")                    'Remove Chars from Port
            hGetMotorPosition = GetProcAddress(hLib, "GetMotorPosition")                'Get Motor Position
            hWaitForChar = GetProcAddress(hLib, "WaitForChar")                          'Wait for Char
            hWaitForCharMotorPosition = GetProcAddress(hLib, "WaitForCharWithMotorPosition")    'Wait for Char and Get Motor Position while waiting
            hResetDriverFunctions = GetProcAddress(hLib, "ResetDriverFunctions")                'Reset Driver Functions for recovery
    End Select
    LoadDriver = hLib
End Function

    Public Function ReleaseDriver()
        Select Case hPortClose
            Case 0
            Case Else
                ClosePort
        End Select
        Select Case hHideTerminal
            Case 0
            Case Else
                HideTerminal
        End Select
        Select Case hLib
            Case 0
            Case Else
                FreeLibrary (hLib)
        End Select
    End Function

Public Function DriverTerminalShowState(ByVal StateToShow As Long, Optional ByVal ParentHwnd As Long) As Long
    Select Case StateToShow
        Case 0
            Select Case hHideTerminal       'Check if function exists
                Case 0
                Case Else
                    DriverTerminalShowState = HideTerminal      'Call function
            End Select
        Case 1
            Select Case hShowTerminal       'Check if function exists
                Case 0
                Case Else
                    Select Case ParentHwnd
                        Case 0
                            DriverTerminalShowState = ShowTerminal(0)    'Call function
                        Case Else
                            DriverTerminalShowState = ShowTerminal(ByVal ParentHwnd)    'Call function
                    End Select
            End Select
    End Select
End Function

Public Function PortOpen(ByVal PortNumber As Long, ByVal BaudRate As Long) As Long
    Select Case hPortOpen       'Check if function exists
        Case 0
        Case Else
            Select Case PortNumber      'See if port is valid
                Case Is < 1, Is > 255
                    PortOpen = 0
                Case Else
                    Select Case BaudRate    'See if baudrate is valid
                        Case 9600, 19200, 38400
                            PortOpen = OpenPort(ByVal PortNumber, ByVal BaudRate)       'Call function
                        Case Else
                            PortOpen = 0
                    End Select
            End Select
    End Select
End Function

Public Function PortClose() As Long
    Select Case hPortClose
        Case 0          'See if function exists
        Case Else
            PortClose = ClosePort   'Call function
    End Select
End Function

Public Function PortIsOpen() As Long
    Select Case hIsPortOpen          'See if function exists
        Case 0
        Case Else
            PortIsOpen = IsPortOpen     'Call function
    End Select
End Function

Public Function PortSendCommands(ByVal CommandToSend As String) As Long
    Select Case hSendToPort          'See if function exists
        Case 0
        Case Else
            PortSendCommands = DriverSendToPort(ByVal CommandToSend)    'Call function
    End Select
End Function

Public Function PortReadReply() As String
    Select Case hReadFromPort       'See if function exists
        Case 0
        Case Else
            PortReadReply = ReadFromPort    'Call function
    End Select
End Function

Public Function PortCountChars() As Long
    Select Case hCountChars     'See if function exists
        Case 0
        Case Else
            PortCountChars = CountCharsAtPort       'Call function
    End Select
End Function

Public Function PortSearchForChars(ByVal CharsToFind As String) As Long
    Select Case hSearchForChars     'See if function exists
        Case 0
        Case Else
            PortSearchForChars = SearchForChars(ByVal CharsToFind)      'Call function
    End Select
End Function

Public Function PortClear() As Long
    Select Case hClearPort      'See if function exists
        Case 0
        Case Else
            PortClear = ClearPort       'Call function
    End Select
End Function

Public Function PortRemoveChars(ByVal StringToRemove As String) As Long
    Select Case hRemoveFromPort     'See if function exists
        Case 0
        Case Else
            PortRemoveChars = RemoveFromPort(ByVal StringToRemove)      'Call function
    End Select
End Function

Public Function MotorPosition(ByVal MotorNumber As Long) As String
    Select Case hGetMotorPosition       'See if function exists
        Case 0
        Case Else
            MotorPosition = GetMotorPosition(ByVal MotorNumber)     'Call function
    End Select
End Function

Public Function PortWaitForChar(ByVal CharToWaitFor As String, Optional ByVal TimeOutTime As Long) As Long
    Select Case hWaitForChar        'See if function exists
        Case 0
        Case Else
            Select Case TimeOutTime
                Case 0
                    PortWaitForChar = WaitForChar(ByVal CharToWaitFor)       'Call function
                Case Else
                    PortWaitForChar = WaitForChar(ByVal CharToWaitFor, ByVal TimeOutTime)       'Call function
            End Select
    End Select
End Function

Public Function PortWaitForCharWithMotorPosition(ByVal CharToWaitFor As String, Optional ByVal TimeOutTime As Long) As Long
    Select Case hWaitForCharMotorPosition        'See if function exists
        Case 0
        Case Else
            Select Case TimeOutTime
                Case 0
                    PortWaitForCharWithMotorPosition = WaitForCharWithMotorPosition(ByVal CharToWaitFor)       'Call function
                Case Else
                    PortWaitForCharWithMotorPosition = WaitForCharWithMotorPosition(ByVal CharToWaitFor, ByVal TimeOutTime)       'Call function
            End Select
    End Select
End Function

Public Sub DriverResetFunctions()
    Select Case hResetDriverFunctions       'See if sub exists
        Case 0
        Case Else
            ResetDriverFunctions            'Call sub
    End Select
End Sub
