VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form FrmDriverVb6 
   Caption         =   "Examples with VXM Driver"
   ClientHeight    =   1410
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3945
   LinkTopic       =   "Form1"
   ScaleHeight     =   1410
   ScaleWidth      =   3945
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   240
      Top             =   720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton CmdLoadExample 
      Caption         =   "Load Example"
      Height          =   375
      Left            =   1080
      TabIndex        =   2
      Top             =   840
      Width           =   2055
   End
   Begin VB.CheckBox ChkShowTerminal 
      Caption         =   "Show Debug Window"
      Height          =   255
      Left            =   1080
      TabIndex        =   1
      Top             =   480
      Value           =   1  'Checked
      Width           =   2055
   End
   Begin VB.Label Label1 
      Caption         =   "See Source Code for Details"
      Height          =   255
      Left            =   1080
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "FrmDriverVb6"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'**********************************************************************************************
'*** All examples follow the sequence below to correctly communicate with the VXM
'*** 1.) Open the port with the correct port number and baudrate. (typically port 1 baudrate 9600)
'*** 2.) Bring VXM online to respond to computer commands (typically "F" command)
'*** 3.) User Reads Motor Position (this is done only from computer control and does not work with "stand-alone" VXM applications)
'*** 4.) User sends VXM commands to be run
'*** 5.) User runs commands sent to VXM
'*** 6.) User waits for response from VXM (this is done only from computer control and does not work with "stand-alone" VXM applications)
'*** 7.) User Reads Motor Position (this is done only from computer control and does not work with "stand-alone" VXM applications)
'*** 8.) User performs some other process
'*** 9.) User repeats steps 3 - 6 as necessary
'*** 10.) Bring VXM offline ("stand-alone") mode
'*** 11.) User closes the port so other applications can use the port as needed
'**********************************************************************************************

'*** Declare a variable for class wrapper to VXM Driver
Private Vxm As ClsVxmDriverVb6
Private DriverLoaded As Long

Private Sub CmdLoadExample_Click()
    Dim FileNumber As Long
    Dim VxmCommand As String
    Dim TempCommand As String
'********************************************************************************************************
'*** THIS BLOCK MAY REPLACED WITH Vxm.LoadDriver(".\Driver\VxmDriver.dll") IF THE DRIVER IS IN THE    ***
'*** APPLICATION PATH IN THE DRIVER FOLDER                                                            ***
'********************************************************************************************************
'@@@ Get Driver Location
    Select Case DriverLoaded
        Case 0
            With Me
                With .CommonDialog1
                    .DefaultExt = ".dll"
                    .FileName = "VxmDriver.dll"
                    .DialogTitle = "Locate VXM Driver"
                    .Filter = "*.dll|*.dll"
                    .InitDir = ".\Driver\"      'Should be in driver folder
                    .ShowOpen
                End With
            End With
'@@@ Determine if Driver was located and Load it
            Select Case InStr(Me.CommonDialog1.FileName, "\")
                Case 0      'Driver was not picked or path would be here
                Case Else   'Driver was picked so lets load it into memory
                    DriverLoaded = Vxm.LoadDriver(Me.CommonDialog1.FileName)
            End Select
        Case Else
    End Select
'********************************************************************************************************


'@@@ Determine if to show debug terminal
    Vxm.DriverTerminalShowState Me.ChkShowTerminal.Value, Me.hwnd     'If 1 then will show if 0 will hide
'@@@ Get Example Location
    With Me
        With .CommonDialog1
            .DefaultExt = ".txt"
            .FileName = ""
            .DialogTitle = "Locate Example"
            .Filter = "*.txt|*.txt"
            .InitDir = App.Path      'Should be in this folder
            .ShowOpen
            Select Case .FileName
                Case ""
                Case Else
                    FileNumber = FreeFile   ' Get unused file number.
                    Open .FileName For Input As #FileNumber   ' Create file name.
                        Do While Not EOF(FileNumber)   ' Loop until end of file.
                            Line Input #FileNumber, TempCommand   ' Read data into two variables.
                            VxmCommand = VxmCommand + TempCommand + vbCr
                        Loop
                    Close #FileNumber   ' Close file.
            End Select
        End With
    End With
    
'@@@ Decide if to send commands
    Select Case VxmCommand
        Case ""
        Case Else
            With Vxm
                .PortOpen 1, 9600         'Open Port 1 at 9600 baud
                .PortSendCommands VxmCommand    'Send Command
                .PortWaitForChar "^"        'Wait for program finish
                .PortClose                  'Close port
            End With
    End Select
    
'@@@ Now clean up before ending
    Vxm.DriverTerminalShowState 0   'Hide the debug terminal in case it was shown
End Sub

Private Sub Form_Load()
    Set Vxm = New ClsVxmDriverVb6   'Set the class wrapper to use driver
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Vxm.ReleaseDriver
    Set Vxm = Nothing
End Sub
